-- WoW API
local GuildRoster = GuildRoster
local GetGuildInfo = GetGuildInfo
local OldGuildUninvite = GuildUninvite
local GetNumGuildMembers = GetNumGuildMembers
local GetGuildRosterInfo = GetGuildRosterInfo
local GetGuildRosterLastOnline = GetGuildRosterLastOnline
local strfind = strfind
local select = select
local format = format
local unpack = unpack
local pairs = pairs
local _

-- Media
local Font = "Interface\\Addons\\GuildManagement\\Engschrift.ttf"
local Font2 = "Interface\\Addons\\GuildManagement\\Prototype.ttf"
local Blank = "Interface\\AddOns\\GuildManagement\\Blank.tga"
local FontColor = {220/255, 220/255, 220/255}

local Darkest = {67/255, 77/255, 91/255}
local Dark = {23/255, 30/255, 41/255}
local Medium = {160/255, 160/255, 160/255}
local Light = {29/255, 38/255, 51/255}
local Lightest = {67/255, 77/255, 91/255}
local Pale = {220/255, 220/255, 220/255}

local InfoRequested = false
local NumGuildMembers = 0
local NumGuildRanks = 0
local RanksDrawn = false
local DidRemove = false
local TimeMap = {"Hours", "Days", "Months", "Years"}
local Options = {Time = "Months", Number = 2, Rank = 6, Note = "DK"}

local GuildRosterInfo = {}
local GuildRankNumMembers = {}
local RankLines = {}

local Backdrop = {
	bgFile = Blank,
	insets = {top = 0, left = 0, bottom = 0, right = 0},
}

local GuildUninvite = function(n)
	if (n == "Vexisle") then
		print("Now, now. That's not very nice!")
		return
	end
	
	OldGuildUninvite(n)
end

local CreateShadow = function(frame)
	if frame.Shadow then
		return
	end
	
	local Strata = frame:GetFrameStrata()
	local Level = frame:GetFrameLevel()
	
	local Shadow = CreateFrame("Frame", nil, frame)
	--Shadow:SetSize(frame:GetSize())
	Shadow:SetFrameLevel(0)
	Shadow:SetFrameStrata(Strata)
	Shadow:SetFrameLevel(Level)
	Shadow:SetBackdrop(Backdrop)
	Shadow:SetBackdropColor(unpack(Darkest))
	Shadow:SetPoint("TOPLEFT", frame, "TOPLEFT", -1, 1)
	Shadow:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 1, -1)
	
	local TopIn = CreateFrame("Frame", nil, Shadow)
	TopIn:SetHeight(1)
	TopIn:SetPoint("BOTTOMLEFT", Shadow, "TOPLEFT", 0, 0)
	TopIn:SetPoint("BOTTOMRIGHT", Shadow, "TOPRIGHT", 0, 0)
	TopIn:SetBackdrop(Backdrop)
	TopIn:SetBackdropColor(0, 0, 0, 0.3)
	
	local TopOut = CreateFrame("Frame", nil, Shadow)
	TopOut:SetHeight(1)
	TopOut:SetPoint("BOTTOMLEFT", Shadow, "TOPLEFT", 0, 1)
	TopOut:SetPoint("BOTTOMRIGHT", Shadow, "TOPRIGHT", 0, 1)
	TopOut:SetBackdrop(Backdrop)
	TopOut:SetBackdropColor(0, 0, 0, 0.1)
	
	local BottomIn = CreateFrame("Frame", nil, Shadow)
	BottomIn:SetHeight(1)
	BottomIn:SetPoint("TOPLEFT", Shadow, "BOTTOMLEFT", 0, 0)
	BottomIn:SetPoint("TOPRIGHT", Shadow, "BOTTOMRIGHT", 0, 0)
	BottomIn:SetBackdrop(Backdrop)
	BottomIn:SetBackdropColor(0, 0, 0, 0.3)
	
	local BottomOut = CreateFrame("Frame", nil, Shadow)
	BottomOut:SetHeight(1)
	BottomOut:SetPoint("TOPLEFT", Shadow, "BOTTOMLEFT", 0, -1)
	BottomOut:SetPoint("TOPRIGHT", Shadow, "BOTTOMRIGHT", 0, -1)
	BottomOut:SetBackdrop(Backdrop)
	BottomOut:SetBackdropColor(0, 0, 0, 0.1)
	
	local LeftIn = CreateFrame("Frame", nil, Shadow)
	LeftIn:SetWidth(1)
	LeftIn:SetPoint("TOPRIGHT", Shadow, "TOPLEFT", 0, 0)
	LeftIn:SetPoint("BOTTOMRIGHT", Shadow, "BOTTOMLEFT", 0, 0)
	LeftIn:SetBackdrop(Backdrop)
	LeftIn:SetBackdropColor(0, 0, 0, 0.3)
	
	local LeftOut = CreateFrame("Frame", nil, Shadow)
	LeftOut:SetWidth(1)
	LeftOut:SetPoint("TOPRIGHT", Shadow, "TOPLEFT", -1, 0)
	LeftOut:SetPoint("BOTTOMRIGHT", Shadow, "BOTTOMLEFT", -1, 0)
	LeftOut:SetBackdrop(Backdrop)
	LeftOut:SetBackdropColor(0, 0, 0, 0.1)
	
	local RightIn = CreateFrame("Frame", nil, Shadow)
	RightIn:SetWidth(1)
	RightIn:SetPoint("TOPLEFT", Shadow, "TOPRIGHT", 0, 0)
	RightIn:SetPoint("BOTTOMLEFT", Shadow, "BOTTOMRIGHT", 0, 0)
	RightIn:SetBackdrop(Backdrop)
	RightIn:SetBackdropColor(0, 0, 0, 0.3)
	
	local RightOut = CreateFrame("Frame", nil, Shadow)
	RightOut:SetWidth(1)
	RightOut:SetPoint("TOPLEFT", Shadow, "TOPRIGHT", 1, 0)
	RightOut:SetPoint("BOTTOMLEFT", Shadow, "BOTTOMRIGHT", 1, 0)
	RightOut:SetBackdrop(Backdrop)
	RightOut:SetBackdropColor(0, 0, 0, 0.1)
	
	local TopLeft = CreateFrame("Frame", nil, Shadow)
	TopLeft:SetSize(1, 1)
	TopLeft:SetPoint("TOPLEFT", Shadow, "TOPLEFT", -1, 1)
	TopLeft:SetBackdrop(Backdrop)
	TopLeft:SetBackdropColor(0, 0, 0, 0.1)
	
	local TopRight = CreateFrame("Frame", nil, Shadow)
	TopRight:SetSize(1, 1)
	TopRight:SetPoint("TOPRIGHT", Shadow, "TOPRIGHT", 1, 1)
	TopRight:SetBackdrop(Backdrop)
	TopRight:SetBackdropColor(0, 0, 0, 0.1)
	
	local BottomLeft = CreateFrame("Frame", nil, Shadow)
	BottomLeft:SetSize(1, 1)
	BottomLeft:SetPoint("BOTTOMLEFT", Shadow, "BOTTOMLEFT", -1, -1)
	BottomLeft:SetBackdrop(Backdrop)
	BottomLeft:SetBackdropColor(0, 0, 0, 0.1)
	
	local BottomRight = CreateFrame("Frame", nil, Shadow)
	BottomRight:SetSize(1, 1)
	BottomRight:SetPoint("BOTTOMRIGHT", Shadow, "BOTTOMRIGHT", 1, -1)
	BottomRight:SetBackdrop(Backdrop)
	BottomRight:SetBackdropColor(0, 0, 0, 0.1)
	
	frame.Shadow = Shadow
end

local BuildGuildRosterTable = function()
	local Name, Rank, RankIndex, Level, Years, Months, Days, Hours, RealName, OfficerNote, _
	NumGuildMembers = GetNumGuildMembers()
	
	for i = 0, GuildControlGetNumRanks() do
		GuildRankNumMembers[GuildControlGetRankName(i)] = 0
	end
	
	for i = 1, 999 do
		Name, Rank, RankIndex, Level, _, _, _, OfficerNote = GetGuildRosterInfo(i)
		
		if (not Name) then
			return
		end
		
		Years, Months, Days, Hours = GetGuildRosterLastOnline(i)
		Years = Years and Years or 0
		Months = Months and Months or 0
		Days = Days and Days or 0
		Hours = Hours and Hours or 0
		OfficerNote = OfficerNote and OfficerNote or ""
		
		GuildRankNumMembers[Rank] = GuildRankNumMembers[Rank] + 1
		
		GuildRosterInfo[i] = {Name = Name, Rank = Rank, RankIndex = RankIndex, Level = Level, Years = Years, Months = Months, Days = Days, Hours = Hours, GuildIndex = i, Note = OfficerNote}
	end
end

local UpdateNumGuildMembers = function()
	GMUI_MainWindowHeader.Text:SetText(select(1, GetGuildInfo("player")) .. " - " .. NumGuildMembers .. " members")
end

local GetNumEligableKicks = function()
	local NumEligable = 0
	local NumIgnored = 0
	
	for Index, Info in pairs(GuildRosterInfo) do
		if (Info[Options.Time] >= Options.Number) and (Info.RankIndex > Options.Rank) then
			if (Info.Note and strfind(Info.Note, Options.Note)) then
				NumIgnored = NumIgnored + 1
			else
				NumEligable = NumEligable + 1
			end
		end
	end
	
	return NumEligable, NumIgnored
end

local RemoveEligablePlayers = function()
	if (not CanGuildRemove()) then
		return
	end
	
	for Index, Info in pairs(GuildRosterInfo) do
		if (Info[Options.Time] >= Options.Number) and (Info.RankIndex > Options.Rank) then
			if (not strfind(Info.Note, Options.Note)) then
				GuildUninvite(Info.Name)
			end
		end
	end
	
	GuildRosterInfo = nil
	GuildRosterInfo = {}
	DidRemove = true
	
	GMUI_MainWindowRanks:SetAlpha(0)
	GMUI_MainWindowOptions:SetAlpha(0)
	--GMUI_MainWindow:Hide()
	GMUI_MainWindowHeader.Text:SetText("")
	GMUI_MainWindowScanButton.Text:SetTextColor(1, 1, 1)
	GMUI_MainWindow:SetSize(200, 120)
	GMUI_MainWindowScanButton:SetAlpha(1)
	GMUI_MainWindowScanButton.Int = 10
	GMUI_MainWindowScanButton.Text:SetText("Scan Guild")
	GMUI_MainWindowNumKick:SetText("")
	
	--[[
	GMUI_Main_ScanButton:Show()
	GMUI_Main_ScanButton.Busy = true
	InfoRequested = true
	GuildRoster()
	GMUI_Main_ScanButton.Text:SetText("Wait (10)")
	GMUI_Main_ScanButton.Text:SetTextColor(unpack(Medium))
	GMUI_Main_ScanButton.Bar:SetValue(10)
	GMUI_Main_ScanButton:SetScript("OnUpdate", ScanButton_OnUpdate)]]
end

local CreateCheckbox = function(p)
	local Checkbox = CreateFrame("Frame", nil, p)
	Checkbox:SetSize(22, 22)
	Checkbox:SetBackdrop(Backdrop)
	Checkbox:SetBackdropColor(0, 0, 0)
	Checkbox.Boolean = true
	Checkbox:SetScript("OnMouseUp", function(self)
		if self.Boolean then
			self.Boolean = false
			self.Texture:SetStatusBarColor(unpack(Medium))
		else
			self.Boolean = true
			self.Texture:SetStatusBarColor(unpack(Dark))
		end
		
		if self.Hook then
			self:Hook(self.Boolean)
		end
	end)
	
	Checkbox.Texture = CreateFrame("StatusBar", nil, Checkbox)
	Checkbox.Texture:SetSize(20, 20)
	Checkbox.Texture:SetPoint("CENTER", Checkbox, 0, 0)
	Checkbox.Texture:SetMinMaxValues(0, 1)
	Checkbox.Texture:SetValue(1)
	Checkbox.Texture:SetStatusBarTexture(Blank)
	Checkbox.Texture:SetStatusBarColor(unpack(Medium))
	
	Checkbox.Text = Checkbox:CreateFontString(nil, "OVERLAY")
	Checkbox.Text:SetPoint("LEFT", Checkbox, "RIGHT", 3, 0)
	Checkbox.Text:SetFont(Font, 18)
	Checkbox.Text:SetJustifyH("LEFT")
	Checkbox.Text:SetShadowColor(0, 0, 0)
	Checkbox.Text:SetShadowOffset(1.25, -1.25)
	
	return Checkbox
end

local CreateEditbox = function(p)
	local Editbox = CreateFrame("Frame", nil, p)
	Editbox:SetSize(50, 22)
	Editbox:SetBackdrop(Backdrop)
	Editbox:SetBackdropColor(0, 0, 0)
	Editbox.Number = 1
	Editbox.Max = 31
	Editbox.Min = 1
	Editbox.Step = 1
	Editbox:SetScript("OnMouseWheel", function(self, delta)
		if (delta > 0) then
			self.Number = self.Number + self.Step
			
			if (self.Number > self.Max) then
				self.Number = self.Max
			end
		else
			self.Number = self.Number - self.Step
			
			if (self.Number < self.Min) then
				self.Number = self.Min
			end
		end
		
		Editbox.Label:SetText(self.Number)
		
		if self.Hook then
			self:Hook(self.Number)
		end
	end)
	
	Editbox.Texture = CreateFrame("StatusBar", nil, Editbox)
	Editbox.Texture:SetSize(48, 20)
	Editbox.Texture:SetPoint("CENTER", Editbox, 0, 0)
	Editbox.Texture:SetMinMaxValues(0, 1)
	Editbox.Texture:SetValue(1)
	Editbox.Texture:SetStatusBarTexture(Blank)
	Editbox.Texture:SetStatusBarColor(unpack(Dark))
	
	Editbox.Label = Editbox.Texture:CreateFontString(nil, "OVERLAY")
	Editbox.Label:SetPoint("CENTER", Editbox, 0, -2)
	Editbox.Label:SetFont(Font, 18)
	Editbox.Label:SetJustifyH("CENTER")
	Editbox.Label:SetShadowColor(0, 0, 0)
	Editbox.Label:SetShadowOffset(1.25, -1.25)
	Editbox.Label:SetText(Editbox.Number)
	
	return Editbox
end

-- Confirmation popup
local Popup = CreateFrame("Frame", "GMUI_Popup", UIParent)
Popup:SetSize(202, 72)
Popup:SetPoint("CENTER", UIParent, "CENTER", 0, 150)
Popup:SetBackdrop(Backdrop)
Popup:SetBackdropColor(unpack(Darkest))
Popup:Hide()

local PopupInner = CreateFrame("Frame", nil, Popup)
PopupInner:SetPoint("TOPLEFT", Popup, 1, -1)
PopupInner:SetPoint("BOTTOMRIGHT", Popup, -1, 1)
PopupInner:SetBackdrop(Backdrop)
PopupInner:SetBackdropColor(unpack(Dark))

Popup.Label = PopupInner:CreateFontString(nil, "OVERLAY")
Popup.Label:SetPoint("TOP", Popup, "TOP", 0, -5)
Popup.Label:SetWidth(192)
Popup.Label:SetFont(Font, 18)
Popup.Label:SetTextColor(unpack(FontColor))
Popup.Label:SetShadowOffset(1.25, -1.25)
Popup.Label:SetShadowColor(0, 0, 0)
Popup.Label:SetText("Are you sure you want to remove these players?")

Popup.Accept = CreateFrame("Button", nil, PopupInner)
Popup.Accept:SetSize(94, 22)
Popup.Accept:SetPoint("BOTTOMLEFT", Popup, "BOTTOMLEFT", 4, 4)
Popup.Accept:SetBackdrop(Backdrop)
Popup.Accept:SetBackdropColor(unpack(Darkest))
Popup.Accept:SetScript("OnEnter", Button_OnEnter)
Popup.Accept:SetScript("OnLeave", Button_OnLeave)
Popup.Accept:SetScript("OnMouseUp", function(self)
	RemoveEligablePlayers()
	GMUI_Popup:Hide()
end)

Popup.AcceptInner = CreateFrame("Frame", nil, Popup.Accept)
Popup.AcceptInner:SetPoint("TOPLEFT", Popup.Accept, 1, -1)
Popup.AcceptInner:SetPoint("BOTTOMRIGHT", Popup.Accept, -1, 1)
Popup.AcceptInner:SetBackdrop(Backdrop)
Popup.AcceptInner:SetBackdropColor(unpack(Dark))

Popup.Accept.Label = Popup.AcceptInner:CreateFontString(nil, "OVERLAY")
Popup.Accept.Label:SetPoint("CENTER", Popup.AcceptInner, "CENTER", 0, -1)
Popup.Accept.Label:SetFont(Font, 18)
Popup.Accept.Label:SetTextColor(unpack(FontColor))
Popup.Accept.Label:SetShadowOffset(1.25, -1.25)
Popup.Accept.Label:SetShadowColor(0, 0, 0)
Popup.Accept.Label:SetText("Accept")

Popup.Cancel = CreateFrame("Button", nil, PopupInner)
Popup.Cancel:SetSize(94, 22)
Popup.Cancel:SetPoint("BOTTOMRIGHT", Popup, "BOTTOMRIGHT", -4, 4)
Popup.Cancel:SetBackdrop(Backdrop)
Popup.Cancel:SetBackdropColor(unpack(Darkest))
Popup.Cancel:SetScript("OnEnter", Button_OnEnter)
Popup.Cancel:SetScript("OnLeave", Button_OnLeave)
Popup.Cancel:SetScript("OnMouseUp", function(self)
	GMUI_Popup:Hide()
end)

Popup.CancelInner = CreateFrame("Frame", nil, Popup.Cancel)
Popup.CancelInner:SetPoint("TOPLEFT", Popup.Cancel, 1, -1)
Popup.CancelInner:SetPoint("BOTTOMRIGHT", Popup.Cancel, -1, 1)
Popup.CancelInner:SetBackdrop(Backdrop)
Popup.CancelInner:SetBackdropColor(unpack(Dark))

Popup.Cancel.Label = Popup.CancelInner:CreateFontString(nil, "OVERLAY")
Popup.Cancel.Label:SetPoint("CENTER", Popup.CancelInner, "CENTER", 0, -1)
Popup.Cancel.Label:SetFont(Font, 16)
Popup.Cancel.Label:SetTextColor(unpack(FontColor))
Popup.Cancel.Label:SetShadowOffset(1.25, -1.25)
Popup.Cancel.Label:SetShadowColor(0, 0, 0)
Popup.Cancel.Label:SetText("Cancel")

-- Main window
local GMUI_Main = CreateFrame("Frame", "GMUI_MainWindow", UIParent)
GMUI_Main:SetSize(200, 120)
GMUI_Main:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
GMUI_Main:SetBackdrop(Backdrop)
GMUI_Main:SetBackdropColor(unpack(Dark))
GMUI_Main:SetAlpha(0)
GMUI_Main:Hide()

CreateShadow(GMUI_Main)

GMUI_Main.AnimGroup = CreateAnimationGroup(GMUI_Main)

GMUI_Main.Width = GMUI_Main.AnimGroup:CreateAnimation("Width")
GMUI_Main.Width:SetSmoothing("out")
GMUI_Main.Width:SetDuration(0.2)
GMUI_Main.Width:SetChange(361)

GMUI_Main.Height = GMUI_Main.AnimGroup:CreateAnimation("Height")
GMUI_Main.Height:SetSmoothing("out")
GMUI_Main.Height:SetDuration(0.2)
GMUI_Main.Height:SetChange(200)
GMUI_Main.Height:SetScript("OnFinished", function() GMUI_MainWindowRanks.FadeIn:Play() UpdateNumGuildMembers() end)

GMUI_Main.FadeOut = CreateAnimationGroup(GMUI_Main):CreateAnimation("Fade")
GMUI_Main.FadeOut:SetSmoothing("out")
GMUI_Main.FadeOut:SetDuration(0.2)
GMUI_Main.FadeOut:SetChange(0)
GMUI_Main.FadeOut:SetScript("OnFinished", function() GMUI_Main:Hide() end)

GMUI_Main.FadeIn = CreateAnimationGroup(GMUI_Main):CreateAnimation("Fade")
GMUI_Main.FadeIn:SetSmoothing("in")
GMUI_Main.FadeIn:SetDuration(0.2)
GMUI_Main.FadeIn:SetChange(1)

-- Header
local GMUI_Main_Header = CreateFrame("Frame", "GMUI_MainWindowHeader", GMUI_Main)
GMUI_Main_Header:SetHeight(22)
GMUI_Main_Header:SetPoint("TOPLEFT", GMUI_Main, "TOPLEFT", 0, 0)
GMUI_Main_Header:SetPoint("TOPRIGHT", GMUI_Main, "TOPRIGHT", 0, 0)
GMUI_Main_Header:SetBackdrop(Backdrop)
GMUI_Main_Header:SetBackdropColor(unpack(Darkest))
GMUI_Main_Header:EnableMouse(true)
GMUI_Main:SetMovable(true)
GMUI_Main_Header:SetMovable(true)
GMUI_Main_Header:RegisterForDrag("LeftButton")
GMUI_Main_Header:SetScript("OnDragStart", function() GMUI_Main:StartMoving() end)
GMUI_Main_Header:SetScript("OnDragStop", function() GMUI_Main:StopMovingOrSizing() end)

GMUI_Main_Header.Text = GMUI_Main_Header:CreateFontString(nil, "OVERLAY")
GMUI_Main_Header.Text:SetFont(Font, 18)
GMUI_Main_Header.Text:SetPoint("LEFT", GMUI_Main_Header, 3, -1)
GMUI_Main_Header.Text:SetShadowColor(0, 0, 0)
GMUI_Main_Header.Text:SetShadowOffset(1.25, -1.25)
GMUI_Main_Header.Text:SetJustifyH("LEFT")


-- Close Button
local GMUI_Main_Close = CreateFrame("Frame", nil, GMUI_Main)
GMUI_Main_Close:SetFrameStrata("HIGH")
GMUI_Main_Close:SetSize(22, 22)
GMUI_Main_Close:SetPoint("TOPRIGHT", GMUI_Main, "TOPRIGHT", 0, 0)
GMUI_Main_Close:SetScript("OnEnter", function(self) self.Text:SetTextColor(1, 0.1, 0.1) end)
GMUI_Main_Close:SetScript("OnLeave", function(self) self.Text:SetTextColor(1, 1, 1) end)
GMUI_Main_Close:SetScript("OnMouseUp", function() GMUI_Main.FadeOut:Play() end)

GMUI_Main_Close.Text = GMUI_Main_Close:CreateFontString(nil, "OVERLAY")
GMUI_Main_Close.Text:SetFont(Font, 18)
GMUI_Main_Close.Text:SetPoint("CENTER", GMUI_Main_Close, -1, 0)
GMUI_Main_Close.Text:SetShadowColor(0, 0, 0)
GMUI_Main_Close.Text:SetShadowOffset(1.25, -1.25)
GMUI_Main_Close.Text:SetJustifyH("CENTER")
GMUI_Main_Close.Text:SetText("×")

-- Ranks
local GMUI_Main_Ranks = CreateFrame("Frame", "GMUI_MainWindowRanks", GMUI_Main)
GMUI_Main_Ranks:SetSize(140, 178)
GMUI_Main_Ranks:SetPoint("BOTTOMRIGHT", GMUI_Main, "BOTTOMRIGHT", 0, 0)
GMUI_Main_Ranks:SetBackdrop(Backdrop)
GMUI_Main_Ranks:SetBackdropColor(unpack(Dark))
GMUI_Main_Ranks:SetAlpha(0)

GMUI_Main_Ranks.FadeIn = CreateAnimationGroup(GMUI_Main_Ranks):CreateAnimation("Fade")
GMUI_Main_Ranks.FadeIn:SetSmoothing("out")
GMUI_Main_Ranks.FadeIn:SetDuration(0.2)
GMUI_Main_Ranks.FadeIn:SetChange(1)
GMUI_Main_Ranks.FadeIn:SetScript("OnFinished", function() GMUI_MainWindowOptions.FadeIn:Play() end)

local DrawRanks = function()
	if RanksDrawn then
		for i = 0, GuildControlGetNumRanks() do
			RankLines[i].Count:SetText(GuildRankNumMembers[GuildControlGetRankName(i)])
		end
	else
		NumGuildRanks = GuildControlGetNumRanks()
		
		local Line
		local Height = (178 / NumGuildRanks)
		local R, G, B = unpack(Lightest)
		
		for i = 0, GuildControlGetNumRanks() do
			Line = CreateFrame("Frame", "GMUIRankLine"..i, GMUI_Main_Ranks)
			Line:SetSize(140, Height)
			
			Line.Text = Line:CreateFontString(nil, "OVERLAY")
			Line.Text:SetFont(Font, 18)
			Line.Text:SetPoint("LEFT", Line, 4, -1)
			Line.Text:SetShadowColor(0, 0, 0)
			Line.Text:SetShadowOffset(1.25, -1.25)
			Line.Text:SetJustifyH("LEFT")
			Line.Text:SetText(GuildControlGetRankName(i))
			
			Line.Count = Line:CreateFontString(nil, "OVERLAY")
			Line.Count:SetFont(Font, 18)
			Line.Count:SetPoint("RIGHT", Line, -3, -1)
			Line.Count:SetShadowColor(0, 0, 0)
			Line.Count:SetShadowOffset(1.25, -1.25)
			Line.Count:SetJustifyH("RIGHT")
			Line.Count:SetText(GuildRankNumMembers[GuildControlGetRankName(i)])
			
			Line.Highlight = Line:CreateTexture(nil, "OVERLAY")
			Line.Highlight:SetAllPoints()
			Line.Highlight:SetTexture(Blank)
			Line.Highlight:SetVertexColor(0, 0, 0, 0)
			
			Line:SetScript("OnEnter", function(self) self.Highlight:SetVertexColor(R, G, B, 0.2) end)
			Line:SetScript("OnLeave", function(self) self.Highlight:SetVertexColor(R, G, B, 0) end)
			
			if (i == 1) then
				Line:SetPoint("TOPLEFT", GMUI_Main_Ranks, "TOPLEFT", 0, 0)
			else
				Line:SetPoint("TOPLEFT", RankLines[i-1], "BOTTOMLEFT", 0, 0)
			end
			
			RankLines[i] = Line
		end
		
		RanksDrawn = true
	end
end

-- Options
local GMUI_Main_Options = CreateFrame("Frame", "GMUI_MainWindowOptions", GMUI_Main)
GMUI_Main_Options:SetSize(220, 178)
GMUI_Main_Options:SetPoint("BOTTOMLEFT", GMUI_Main, "BOTTOMLEFT", 0, 0)
GMUI_Main_Options:SetBackdrop(Backdrop)
GMUI_Main_Options:SetBackdropColor(unpack(Dark))
GMUI_Main_Options:SetAlpha(0)

GMUI_Main_Options.FadeIn = CreateAnimationGroup(GMUI_Main_Options):CreateAnimation("Fade")
GMUI_Main_Options.FadeIn:SetSmoothing("out")
GMUI_Main_Options.FadeIn:SetDuration(0.2)
GMUI_Main_Options.FadeIn:SetChange(1)


local SideDividerBottom = GMUI_Main_Options:CreateTexture(nil, "OVERLAY")
SideDividerBottom:SetSize(1, 80)
SideDividerBottom:SetPoint("TOP", GMUI_Main_Options, "RIGHT", 0, 0)
SideDividerBottom:SetTexture(Blank)
SideDividerBottom:SetGradientAlpha("VERTICAL", Lightest[1], Lightest[2], Lightest[3], 0, Lightest[1], Lightest[2], Lightest[3], 1)

local SideDividerTop = GMUI_Main_Options:CreateTexture(nil, "OVERLAY")
SideDividerTop:SetSize(1, 80)
SideDividerTop:SetPoint("BOTTOM", GMUI_Main_Options, "RIGHT", 0, 0)
SideDividerTop:SetTexture(Blank)
SideDividerTop:SetGradientAlpha("VERTICAL", Lightest[1], Lightest[2], Lightest[3], 1, Lightest[1], Lightest[2], Lightest[3], 0)

local NumKickLabel = GMUI_Main_Options:CreateFontString("GMUI_MainWindowNumKick", "OVERLAY")
NumKickLabel:SetFont(Font, 18)
NumKickLabel:SetPoint("BOTTOMLEFT", GMUI_Main_Options, "BOTTOMLEFT", 3, 0)
NumKickLabel:SetShadowColor(0, 0, 0)
NumKickLabel:SetShadowOffset(1.25, -1.25)
NumKickLabel:SetJustifyH("LEFT")

local UpdateNumKickLabel = function()
	local Total, Ignored = GetNumEligableKicks()
	local Message
	
	if (Ignored > 0) then
		Message = format("%s to be removed (%s ignored)", Total, Ignored)
	else
		Message = format("%s to be removed", Total)
	end
	
	NumKickLabel:SetText(Message)
end

local TimeOfflineLabel = GMUI_Main_Options:CreateFontString(nil, "OVERLAY")
TimeOfflineLabel:SetFont(Font, 18)
TimeOfflineLabel:SetPoint("TOPLEFT", GMUI_Main_Options, "TOPLEFT", 3, -3)
TimeOfflineLabel:SetShadowColor(0, 0, 0)
TimeOfflineLabel:SetShadowOffset(1.25, -1.25)
TimeOfflineLabel:SetJustifyH("LEFT")
TimeOfflineLabel:SetText("Time offline:")

local TimeDropDown = CreateFrame("Frame", nil, GMUI_Main_Options)
TimeDropDown:SetSize(120, 22)
TimeDropDown:SetPoint("TOPRIGHT", GMUI_Main_Options, "TOPRIGHT", -3, -3)
TimeDropDown:SetBackdrop(Backdrop)
TimeDropDown:SetBackdropColor(unpack(Darkest))

TimeDropDown.Inside = CreateFrame("Frame", nil, TimeDropDown)
TimeDropDown.Inside:SetSize(118, 20)
TimeDropDown.Inside:SetPoint("CENTER", TimeDropDown, "CENTER", 0, 0)
TimeDropDown.Inside:SetBackdrop(Backdrop)
TimeDropDown.Inside:SetBackdropColor(unpack(Light))

TimeDropDown.Label = TimeDropDown.Inside:CreateFontString(nil, "OVERLAY")
TimeDropDown.Label:SetPoint("LEFT", TimeDropDown, "LEFT", 4, -1.5)
TimeDropDown.Label:SetFont(Font, 18)
TimeDropDown.Label:SetJustifyH("LEFT")
TimeDropDown.Label:SetShadowColor(0, 0, 0)
TimeDropDown.Label:SetShadowOffset(1.25, -1.25)
TimeDropDown.Label:SetText("Months")

TimeDropDown.Button = CreateFrame("Frame", nil, TimeDropDown.Inside)
TimeDropDown.Button:SetSize(22, 22)
TimeDropDown.Button:SetPoint("RIGHT", TimeDropDown, "RIGHT", 0, 0)
TimeDropDown.Button.Pos = -1
TimeDropDown.Button:SetFrameStrata("HIGH")
TimeDropDown.Button:SetBackdrop(Backdrop)
TimeDropDown.Button:SetBackdropColor(unpack(Darkest))

TimeDropDown.ButtonInside = CreateFrame("Frame", nil, TimeDropDown.Button)
TimeDropDown.ButtonInside:SetSize(20, 20)
TimeDropDown.ButtonInside:SetPoint("CENTER", TimeDropDown.Button, "CENTER", 0, 0)
TimeDropDown.ButtonInside:SetBackdrop(Backdrop)
TimeDropDown.ButtonInside:SetBackdropColor(unpack(Dark))

TimeDropDown.Button.Label = TimeDropDown.ButtonInside:CreateFontString(nil, "OVERLAY")
TimeDropDown.Button.Label:SetPoint("CENTER", TimeDropDown.ButtonInside, "CENTER", 0, -1.5)
TimeDropDown.Button.Label:SetFont("Interface\\Addons\\GuildManagement\\Arial.ttf", 14)
TimeDropDown.Button.Label:SetShadowOffset(1.25, -1.25)
TimeDropDown.Button.Label:SetShadowColor(0, 0, 0)
TimeDropDown.Button.Label:SetText("▼")

TimeDropDown.Options = CreateFrame("Frame", nil, TimeDropDown)
TimeDropDown.Options:SetSize(120, (4 * 20))
TimeDropDown.Options:SetPoint("TOP", TimeDropDown, "BOTTOM", 0, -3)
TimeDropDown.Options:SetFrameStrata("DIALOG")
TimeDropDown.Options:Hide()
TimeDropDown.Options:SetBackdrop(Backdrop)
TimeDropDown.Options:SetBackdropColor(unpack(Light))

TimeDropDown.Button:SetScript("OnMouseUp", function(self)
	if (self.Pos == 1) then
		TimeDropDown.Options:Hide()
		TimeDropDown.Button.Label:SetText("▼")
		
		self.Pos = -1
	else
		TimeDropDown.Options:Show()
		TimeDropDown.Button.Label:SetText("▲")
		
		self.Pos = 1
	end
end)

for i = 1, 4 do
	TimeDropDown.Options[i] = CreateFrame("Frame", nil, TimeDropDown.Options)
	TimeDropDown.Options[i]:SetSize(120, 20)
	TimeDropDown.Options[i]:SetPoint("TOP", TimeDropDown.Options, "TOP", 0, -(20 * (i - 1)))
	TimeDropDown.Options[i].Index = i
	TimeDropDown.Options[i]:SetBackdrop(Backdrop)
	TimeDropDown.Options[i]:SetBackdropColor(unpack(Darkest))
	
	TimeDropDown.Options[i]:SetScript("OnEnter", function(self) self.bg:SetVertexColor(1, 1, 1, 0.2) end)
	TimeDropDown.Options[i]:SetScript("OnLeave", function(self) self.bg:SetVertexColor(0, 0, 0, 0) end)
	
	TimeDropDown.Options[i]:SetScript("OnMouseUp", function(self)
		TimeDropDown.Label:SetText(self.Label:GetText())
		TimeDropDown.Options:Hide()
		TimeDropDown.Button.Label:SetText("V")
		TimeDropDown.Button.Pos = -1
		Options.Time = TimeMap[self.Index]
		UpdateNumKickLabel()
		
		GMUI_SetXLabel:SetText("Set " .. strlower(Options.Time) .. ":")
	end)
	
	TimeDropDown.Options[i].bg = TimeDropDown.Options[i]:CreateTexture(nil, "OVERLAY")
	TimeDropDown.Options[i].bg:SetSize(120, 20)
	TimeDropDown.Options[i].bg:SetPoint("CENTER", TimeDropDown.Options[i], "CENTER", 0, 0)
	TimeDropDown.Options[i].bg:SetTexture(Blank)
	TimeDropDown.Options[i].bg:SetVertexColor(0, 0, 0, 0)
	
	TimeDropDown.Options[i].Label = TimeDropDown.Options[i]:CreateFontString(nil, "OVERLAY")
	TimeDropDown.Options[i].Label:SetPoint("LEFT", TimeDropDown.Options[i], "LEFT", 4, -1.5)
	TimeDropDown.Options[i].Label:SetFont(Font, 16)
	TimeDropDown.Options[i].Label:SetShadowOffset(1.25, -1.25)
	TimeDropDown.Options[i].Label:SetShadowColor(0, 0, 0)
	TimeDropDown.Options[i].Label:SetText(TimeMap[i])
end


local SetXLabel = GMUI_Main_Options:CreateFontString("GMUI_SetXLabel", "OVERLAY")
SetXLabel:SetFont(Font, 18)
SetXLabel:SetPoint("TOPLEFT", GMUI_Main_Options, "TOPLEFT", 3, -30)
SetXLabel:SetShadowColor(0, 0, 0)
SetXLabel:SetShadowOffset(1.25, -1.25)
SetXLabel:SetJustifyH("LEFT")
SetXLabel:SetText("Set months:")

local EB_OnClick = function(self)
	self:SetAutoFocus(true)
end

local EB_OnEscapePressed = function(self)
	self:SetAutoFocus(false)
	self:ClearFocus()
end

local EB_OnEnterPressed = function(self)
	self:SetAutoFocus(false)
	self:ClearFocus()
	
	Options.Number = tonumber(self:GetText()) or 0
	UpdateNumKickLabel()
end

local EB_OnEditFocusLost = function(self)
	self:SetAutoFocus(false)
end

local EditBoxBG = CreateFrame("Frame", nil, GMUI_Main_Options)
EditBoxBG:SetSize(60, 22)
EditBoxBG:SetPoint("TOPRIGHT", GMUI_Main_Options, "TOPRIGHT", -3, -28)
EditBoxBG:SetBackdrop(Backdrop)
EditBoxBG:SetBackdropColor(unpack(Darkest))

EditBoxBG.Inside = CreateFrame("Frame", nil, EditBoxBG)
EditBoxBG.Inside:SetSize(58, 20)
EditBoxBG.Inside:SetPoint("CENTER", EditBoxBG, "CENTER", 0, 0)
EditBoxBG.Inside:SetBackdrop(Backdrop)
EditBoxBG.Inside:SetBackdropColor(unpack(Light))

local EditBox = CreateFrame("EditBox", nil, EditBoxBG.Inside)
EditBox:SetSize(58, 20)
EditBox:SetPoint("CENTER", EditBoxBG.Inside, "CENTER", 0, -2)
EditBox:SetFont(Font, 18)
EditBox:SetShadowColor(0, 0, 0)
EditBox:SetShadowOffset(1.25, -1.25)
EditBox:SetJustifyH("CENTER")
EditBox:SetAutoFocus(false)
EditBox:SetScript("OnMouseUp", EB_OnClick)
EditBox:SetScript("OnEscapePressed", EB_OnEscapePressed)
EditBox:SetScript("OnEnterPressed", EB_OnEnterPressed)
EditBox:SetScript("OnEditFocusLost", EB_OnEditFocusLost)
EditBox:SetNumeric(true)
EditBox:SetMaxLetters(2)
EditBox:SetText(Options.Number)

local UpdateGuildRankDropDown = function()
	local NumRanks = GuildControlGetNumRanks()
	
	local TimeDropDown = CreateFrame("Frame", nil, GMUI_Main_Options)
	TimeDropDown:SetSize(120, 22)
	TimeDropDown:SetPoint("TOPRIGHT", GMUI_Main_Options, "TOPRIGHT", -3, -53)
	TimeDropDown:SetBackdrop(Backdrop)
	TimeDropDown:SetBackdropColor(unpack(Darkest))
	
	TimeDropDown.Inside = CreateFrame("Frame", nil, TimeDropDown)
	TimeDropDown.Inside:SetSize(118, 20)
	TimeDropDown.Inside:SetPoint("CENTER", TimeDropDown, "CENTER", 0, 0)
	TimeDropDown.Inside:SetBackdrop(Backdrop)
	TimeDropDown.Inside:SetBackdropColor(unpack(Light))
	
	TimeDropDown.Label = TimeDropDown.Inside:CreateFontString(nil, "OVERLAY")
	TimeDropDown.Label:SetPoint("LEFT", TimeDropDown, "LEFT", 4, -1.5)
	TimeDropDown.Label:SetFont(Font, 18)
	TimeDropDown.Label:SetJustifyH("LEFT")
	TimeDropDown.Label:SetShadowColor(0, 0, 0)
	TimeDropDown.Label:SetShadowOffset(1.25, -1.25)
	TimeDropDown.Label:SetText(GuildControlGetRankName(Options.Rank))
	
	TimeDropDown.Button = CreateFrame("Frame", nil, TimeDropDown.Inside)
	TimeDropDown.Button:SetSize(22, 22)
	TimeDropDown.Button:SetPoint("RIGHT", TimeDropDown, "RIGHT", 0, 0)
	TimeDropDown.Button.Pos = -1
	TimeDropDown.Button:SetFrameStrata("HIGH")
	TimeDropDown.Button:SetBackdrop(Backdrop)
	TimeDropDown.Button:SetBackdropColor(unpack(Darkest))
	
	TimeDropDown.ButtonInside = CreateFrame("Frame", nil, TimeDropDown.Button)
	TimeDropDown.ButtonInside:SetSize(20, 20)
	TimeDropDown.ButtonInside:SetPoint("CENTER", TimeDropDown.Button, "CENTER", 0, 0)
	TimeDropDown.ButtonInside:SetBackdrop(Backdrop)
	TimeDropDown.ButtonInside:SetBackdropColor(unpack(Dark))
	
	TimeDropDown.Button.Label = TimeDropDown.ButtonInside:CreateFontString(nil, "OVERLAY")
	TimeDropDown.Button.Label:SetPoint("CENTER", TimeDropDown.ButtonInside, "CENTER", 0, -1.5)
	TimeDropDown.Button.Label:SetFont("Interface\\Addons\\GuildManagement\\Arial.ttf", 14)
	TimeDropDown.Button.Label:SetShadowOffset(1.25, -1.25)
	TimeDropDown.Button.Label:SetShadowColor(0, 0, 0)
	TimeDropDown.Button.Label:SetText("▼")
	
	TimeDropDown.Options = CreateFrame("Frame", nil, TimeDropDown)
	TimeDropDown.Options:SetSize(120, (4 * 20))
	TimeDropDown.Options:SetPoint("TOP", TimeDropDown, "BOTTOM", 0, -3)
	TimeDropDown.Options:SetFrameStrata("DIALOG")
	TimeDropDown.Options:Hide()
	TimeDropDown.Options:SetBackdrop(Backdrop)
	TimeDropDown.Options:SetBackdropColor(unpack(Medium))
	
	TimeDropDown.Button:SetScript("OnMouseUp", function(self)
		if (self.Pos == 1) then
			TimeDropDown.Options:Hide()
			TimeDropDown.Button.Label:SetText("▼")
			
			self.Pos = -1
		else
			TimeDropDown.Options:Show()
			TimeDropDown.Button.Label:SetText("▲")
			
			self.Pos = 1
		end
	end)
	
	for i = 1, NumRanks do
		TimeDropDown.Options[i] = CreateFrame("Frame", nil, TimeDropDown.Options)
		TimeDropDown.Options[i]:SetSize(120, 20)
		TimeDropDown.Options[i]:SetPoint("TOP", TimeDropDown.Options, "TOP", 0, -(20 * (i - 1)))
		TimeDropDown.Options[i].Index = i-1
		TimeDropDown.Options[i]:SetBackdrop(Backdrop)
		TimeDropDown.Options[i]:SetBackdropColor(unpack(Darkest))
		
		TimeDropDown.Options[i]:SetScript("OnEnter", function(self) self.bg:SetVertexColor(1, 1, 1, 0.2) end)
		TimeDropDown.Options[i]:SetScript("OnLeave", function(self) self.bg:SetVertexColor(0, 0, 0, 0) end)
		
		TimeDropDown.Options[i]:SetScript("OnMouseUp", function(self)
			TimeDropDown.Label:SetText(self.Label:GetText())
			TimeDropDown.Options:Hide()
			TimeDropDown.Button.Label:SetText("▼")
			TimeDropDown.Button.Pos = -1
			Options.Rank = i
			
			UpdateNumKickLabel()
		end)
		
		TimeDropDown.Options[i].bg = TimeDropDown.Options[i]:CreateTexture(nil, "OVERLAY")
		TimeDropDown.Options[i].bg:SetSize(120, 20)
		TimeDropDown.Options[i].bg:SetPoint("CENTER", TimeDropDown.Options[i], "CENTER", 0, 0)
		TimeDropDown.Options[i].bg:SetTexture(Blank)
		TimeDropDown.Options[i].bg:SetVertexColor(0, 0, 0, 0)
		
		TimeDropDown.Options[i].Label = TimeDropDown.Options[i]:CreateFontString(nil, "OVERLAY")
		TimeDropDown.Options[i].Label:SetPoint("LEFT", TimeDropDown.Options[i], "LEFT", 4, -1.5)
		TimeDropDown.Options[i].Label:SetFont(Font, 16)
		TimeDropDown.Options[i].Label:SetShadowOffset(1.25, -1.25)
		TimeDropDown.Options[i].Label:SetShadowColor(0, 0, 0)
		TimeDropDown.Options[i].Label:SetText(GuildControlGetRankName(i))
	end
end


local SetXLabel = GMUI_Main_Options:CreateFontString(nil, "OVERLAY")
SetXLabel:SetFont(Font, 18)
SetXLabel:SetPoint("TOPLEFT", GMUI_Main_Options, "TOPLEFT", 3, -56)
SetXLabel:SetShadowColor(0, 0, 0)
SetXLabel:SetShadowOffset(1.25, -1.25)
SetXLabel:SetJustifyH("LEFT")
SetXLabel:SetText("Below rank:")

local DontKickLabel = GMUI_Main_Options:CreateFontString(nil, "OVERLAY")
DontKickLabel:SetFont(Font, 18)
DontKickLabel:SetPoint("TOPLEFT", GMUI_Main_Options, "TOPLEFT", 3, -81)
DontKickLabel:SetShadowColor(0, 0, 0)
DontKickLabel:SetShadowOffset(1.25, -1.25)
DontKickLabel:SetJustifyH("LEFT")
DontKickLabel:SetText("Don't kick:")

local EB_OnEnterPressedText = function(self)
	self:SetAutoFocus(false)
	self:ClearFocus()
	
	Options.Note = self:GetText()
	UpdateNumKickLabel()
end

local EditBox2BG = CreateFrame("Frame", nil, GMUI_Main_Options)
EditBox2BG:SetSize(120, 22)
EditBox2BG:SetPoint("TOPRIGHT", GMUI_Main_Options, "TOPRIGHT", -3, -78)
EditBox2BG:SetBackdrop(Backdrop)
EditBox2BG:SetBackdropColor(unpack(Darkest))

EditBox2BG.Inside = CreateFrame("Frame", nil, EditBox2BG)
EditBox2BG.Inside:SetSize(118, 20)
EditBox2BG.Inside:SetPoint("CENTER", EditBox2BG, "CENTER", 0, 0)
EditBox2BG.Inside:SetBackdrop(Backdrop)
EditBox2BG.Inside:SetBackdropColor(unpack(Light))

local EditBox2 = CreateFrame("EditBox", nil, EditBox2BG.Inside)
EditBox2:SetSize(118, 20)
EditBox2:SetPoint("CENTER", EditBox2BG.Inside, "CENTER", 0, -2)
EditBox2:SetFont(Font, 18)
EditBox2:SetShadowColor(0, 0, 0)
EditBox2:SetShadowOffset(1.25, -1.25)
EditBox2:SetJustifyH("CENTER")
EditBox2:SetAutoFocus(false)
EditBox2:SetScript("OnMouseUp", EB_OnClick)
EditBox2:SetScript("OnEscapePressed", EB_OnEscapePressed)
EditBox2:SetScript("OnEnterPressed", EB_OnEnterPressedText)
EditBox2:SetScript("OnEditFocusLost", EB_OnEditFocusLost)
EditBox2:SetText(Options.Note)

local KickButton = CreateFrame("Frame", nil, GMUI_Main_Options)
KickButton:SetSize(212, 22)
KickButton:SetPoint("TOPRIGHT", GMUI_Main_Options, "TOPRIGHT", -3, -104)
KickButton:SetBackdrop(Backdrop)
KickButton:SetBackdropColor(unpack(Darkest))
KickButton:SetScript("OnMouseUp", function() Popup:Show() end)

KickButton.Inside = CreateFrame("Frame", nil, KickButton)
KickButton.Inside:SetSize(210, 20)
KickButton.Inside:SetPoint("CENTER", KickButton, "CENTER", 0, 0)
KickButton.Inside:SetBackdrop(Backdrop)
KickButton.Inside:SetBackdropColor(unpack(Light))

KickButton.Label = KickButton.Inside:CreateFontString(nil, "OVERLAY")
KickButton.Label:SetPoint("CENTER", KickButton, "CENTER", 0, -1.5)
KickButton.Label:SetFont(Font, 18)
KickButton.Label:SetJustifyH("CENTER")
KickButton.Label:SetShadowColor(0, 0, 0)
KickButton.Label:SetShadowOffset(1.25, -1.25)
KickButton.Label:SetText("Remove players")

GMUI_Main_Header.Text = GMUI_Main_Header:CreateFontString(nil, "OVERLAY")
GMUI_Main_Header.Text:SetFont(Font, 18)
GMUI_Main_Header.Text:SetPoint("LEFT", GMUI_Main_Header, 3, -1)
GMUI_Main_Header.Text:SetShadowColor(0, 0, 0)
GMUI_Main_Header.Text:SetShadowOffset(1.25, -1.25)
GMUI_Main_Header.Text:SetJustifyH("LEFT")

-- Scan Button
local GMUI_Main_ScanButton = CreateFrame("Frame", "GMUI_MainWindowScanButton", GMUI_Main_Header)
GMUI_Main_ScanButton:SetSize(120, 22)
GMUI_Main_ScanButton:SetPoint("CENTER", GMUI_Main, "CENTER", 0, 0)
GMUI_Main_ScanButton:SetBackdrop(Backdrop)
GMUI_Main_ScanButton:SetBackdropColor(unpack(Dark))
GMUI_Main_ScanButton:SetFrameLevel(GMUI_Main_Header:GetFrameLevel() + 1)
GMUI_Main_ScanButton.Int = 10

CreateShadow(GMUI_Main_ScanButton)

GMUI_Main_ScanButton.Text = GMUI_Main_ScanButton:CreateFontString(nil, "OVERLAY")
GMUI_Main_ScanButton.Text:SetFont(Font, 18)
GMUI_Main_ScanButton.Text:SetPoint("CENTER", GMUI_Main_ScanButton, 0, -1)
GMUI_Main_ScanButton.Text:SetShadowColor(0, 0, 0)
GMUI_Main_ScanButton.Text:SetShadowOffset(1.25, -1.25)
GMUI_Main_ScanButton.Text:SetJustifyH("CENTER")
GMUI_Main_ScanButton.Text:SetText("Scan Guild")

GMUI_Main_ScanButton.Bar = CreateFrame("StatusBar", nil, GMUI_Main_ScanButton)
GMUI_Main_ScanButton.Bar:SetSize(120, 2)
GMUI_Main_ScanButton.Bar:SetPoint("BOTTOM", GMUI_Main_ScanButton, "BOTTOM", 0, 0)
GMUI_Main_ScanButton.Bar:SetStatusBarTexture(Blank)
GMUI_Main_ScanButton.Bar:SetStatusBarColor(unpack(Pale)) -- 0.1, 1, 0.1
GMUI_Main_ScanButton.Bar:SetMinMaxValues(0, 10)
GMUI_Main_ScanButton.Bar:SetValue(0)

GMUI_Main_ScanButton.Fade = CreateAnimationGroup(GMUI_Main_ScanButton):CreateAnimation("Fade")
GMUI_Main_ScanButton.Fade:SetSmoothing("out")
GMUI_Main_ScanButton.Fade:SetDuration(0.2)
GMUI_Main_ScanButton.Fade:SetChange(-1)
GMUI_Main_ScanButton.Fade:SetScript("OnFinished", function() GMUI_Main.AnimGroup:Play() end)

local ScanButton_OnUpdate = function(self, elapsed)
	self.Int = self.Int - elapsed
	
	if (self.Int <= 0) then
		self:SetScript("OnUpdate", nil)
		self.Busy = false
		self.Bar:SetValue(0)
		
		-- No response from the server, try again.
		if (NumGuildMembers == 0) then
			InfoRequested = true
			GuildRoster()
			self.Busy = false
			self.Bar:SetValue(0)
			GMUI_Main_ScanButton.Fade:Play()
		else
			self.Busy = false
			self.Bar:SetValue(0)
			GMUI_Main_ScanButton.Fade:Play()
		end
		
		return
	end
	
	self.Text:SetText("Wait (" .. format("%.1f", self.Int) .. ")")
	self.Bar:SetValue(self.Int)
end

GMUI_Main_ScanButton:SetScript("OnMouseUp", function(self)
	if (not self.Busy) then
		self.Busy = true
		InfoRequested = true
		GuildRoster()
		self.Text:SetText("Wait (10)")
		self.Text:SetTextColor(unpack(Medium))
		self.Bar:SetValue(10)
		self:SetScript("OnUpdate", ScanButton_OnUpdate)
	end
end)

local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("GUILD_ROSTER_UPDATE")
EventFrame:SetScript("OnEvent", function(self, event)
	if InfoRequested then
		BuildGuildRosterTable()
		DrawRanks()
		UpdateGuildRankDropDown()
		UpdateNumGuildMembers()
		UpdateNumKickLabel()
		InfoRequested = false
	end
end)

SLASH_GUILDMANAGEMENT1 = "/gmui"
SlashCmdList["GUILDMANAGEMENT"] = function(cmd)
	if GMUI_Main:IsShown() then
		GMUI_Main.FadeOut:Play()
	else
		if DidRemove then -- Reset and let us scan
			GMUI_MainWindowRanks:SetAlpha(0)
			GMUI_MainWindowOptions:SetAlpha(0)
			GMUI_Main:SetAlpha(0)
			GMUI_Main:Hide()
			GMUI_Main_Header.Text:SetText("")
			GMUI_Main:SetSize(200, 120)
			GMUI_Main_ScanButton:SetAlpha(1)
			GMUI_Main_ScanButton.Int = 10
			GMUI_Main_ScanButton.Text:SetText("Scan Guild")
			NumKickLabel:SetText("")
			
			DidRemove = false
		end
		
		GMUI_Main:Show()
		GMUI_Main.FadeIn:Play()
	end
end